
#pragma once
#include "B4RDefines.h"
#include "A4988.h"
            
    //~Event: 
    //~Version: 1.0 
    //~Author - 
    //~Libray from Arduino

namespace B4R {
    //~shortname:A4988
    class B4RA4988
    {
        private:
            uint8_t backend[sizeof(A4988)];
            A4988* rcs;
        public: 
            void Initialize(int16_t steps,int16_t dir_pin,int16_t step_pin);     
            void Initialize1(int16_t steps, int16_t dir_pin, int16_t step_pin, int16_t enable_pin);            
            void Initialize2(int16_t steps, int16_t dir_pin, int16_t step_pin, int16_t ms1_pin, int16_t ms2_pin, int16_t ms3_pin);            
            void Initialize3(int16_t steps, int16_t dir_pin, int16_t step_pin, int16_t enable_pin, int16_t ms1_pin, int16_t ms2_pin, int16_t ms3_pin);
            
            void begin(float rpm, int16_t microsteps);
            int16_t setMicrostep(int16_t microsteps);
            int16_t getMicrostep();
            int16_t getSteps();
            void setRPM(float rpm);
            float getRPM();
            float getCurrentRPM();
            void setSpeedProfile(byte mode, int16_t accel, int16_t decel);
            void setSpeedProfile1(ArrayInt* profile);  
            ArrayInt* getSpeedProfile();
            int16_t getAcceleration();
            int16_t getDeceleration();
            void move(int32_t steps);
            void rotate(int32_t deg);
            void rotate1(int16_t deg);
            void rotate2(double deg);
            void setEnableActiveState(int16_t state);
            void enable();
            void disable();
            void startMove(int32_t steps, int32_t time);
            void startRotate(int16_t deg);
            void startRotate1(int32_t deg);
            void startRotate2(double deg);
            int32_t nextAction();
            void startBrake();
            int32_t stop();
            byte getCurrentState();
            int32_t getStepsCompleted();
            int32_t getStepsRemaining();
            int16_t getDirection();
            int32_t getTimeForMove(int32_t steps);
            int32_t calcStepsForRotation(int32_t deg);

            
            #define /*byte Mode_CONSTANT_SPEED;*/            B4R_CONSTANT_SPEED               0
            #define /*byte Mode_LINEAR_SPEED;*/              B4R_LINEAR_SPEED                 1     
             
            #define /*byte State_STOPPED;*/                  B4R_STOPPED                      0
            #define /*byte State_ACCELERATING;*/             B4R_ACCELERATING                 1    
            #define /*byte State_CRUISING;*/                 B4R_CRUISING                     2
            #define /*byte State_DECELERATING;*/             B4R_DECELERATING                 3                     
    };
}

